Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 9019)
@@ -13,24 +13,25 @@
    !!            3.6  !  2012-01  (C. Rousset) add ice boundary conditions for lim3
    !!----------------------------------------------------------------------
-   !!    bdy_dta        : read external data along open boundaries from file
-   !!    bdy_dta_init   : initialise arrays etc for reading of external data
+
    !!----------------------------------------------------------------------
-   USE timing          ! Timing
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE phycst          ! physical constants
-   USE bdy_oce         ! ocean open boundary conditions  
-   USE bdytides        ! tidal forcing at boundaries
-   USE fldread         ! read input fields
-   USE iom             ! IOM library
-   USE in_out_manager  ! I/O logical units
-#if defined key_lim2
-   USE ice_2
-#elif defined key_lim3
-   USE ice
-   USE limvar          ! redistribute ice input into categories
-#endif
-   USE sbcapr
-   USE sbctide         ! Tidal forcing or not
+   !!    bdy_dta      : read external data along open boundaries from file
+   !!    bdy_dta_init : initialise arrays etc for reading of external data
+   !!----------------------------------------------------------------------
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE phycst         ! physical constants
+   USE sbcapr         ! atmospheric pressure forcing
+   USE sbctide        ! Tidal forcing or not
+   USE bdy_oce        ! ocean open boundary conditions  
+   USE bdytides       ! tidal forcing at boundaries
+#if defined key_lim3
+   USE ice            ! sea-ice variables
+   USE icevar         ! redistribute ice input into categories
+#endif
+   !
+   USE fldread        ! read input fields
+   USE iom            ! IOM library
+   USE in_out_manager ! I/O logical units
+   USE timing         ! Timing
 
    IMPLICIT NONE
@@ -50,10 +51,10 @@
 
 #if defined key_lim3
-   LOGICAL :: ll_bdylim3                  ! determine whether ice input is lim2 (F) or lim3 (T) type
-   INTEGER :: jfld_hti, jfld_hts, jfld_ai ! indices of ice thickness, snow thickness and concentration in bf structure
+   INTEGER ::   nice_cat                      ! number of categories in the input file
+   INTEGER ::   jfld_hti, jfld_hts, jfld_ai   ! indices of ice thickness, snow thickness and concentration in bf structure
 #endif
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
@@ -79,5 +80,6 @@
       !                                               ! etc.
       !
-      INTEGER ::  ib_bdy, jfld, jstart, jend, ib, ii, ij, ik, igrd, jl  ! local indices
+      INTEGER ::  jbdy, jfld, jstart, jend, ib, jl  ! dummy loop indices
+      INTEGER ::  ii, ij, ik, igrd                  ! local integers
       INTEGER,          DIMENSION(jpbgrd) ::   ilen1 
       INTEGER, POINTER, DIMENSION(:)      ::   nblen, nblenrim  ! short cuts
@@ -94,39 +96,39 @@
          !-----------------------------
          
-         DO ib_bdy = 1, nb_bdy
+         DO jbdy = 1, nb_bdy
             !
-            nblen => idx_bdy(ib_bdy)%nblen
-            nblenrim => idx_bdy(ib_bdy)%nblenrim
-            dta => dta_bdy(ib_bdy)
-
-            IF( nn_dyn2d_dta(ib_bdy) == 0 ) THEN 
+            nblen    => idx_bdy(jbdy)%nblen
+            nblenrim => idx_bdy(jbdy)%nblenrim
+            dta      => dta_bdy(jbdy)
+            !
+            IF( nn_dyn2d_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
                IF( dta%ll_ssh ) THEN 
                   igrd = 1
                   DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)         
+                     ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                     ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                     dta_bdy(jbdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)         
                   END DO 
-               END IF
+               ENDIF
                IF( dta%ll_u2d ) THEN 
                   igrd = 2
                   DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%u2d(ib) = un_b(ii,ij) * umask(ii,ij,1)         
+                     ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                     ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                     dta_bdy(jbdy)%u2d(ib) = un_b(ii,ij) * umask(ii,ij,1)         
                   END DO 
-               END IF
+               ENDIF
                IF( dta%ll_v2d ) THEN 
                   igrd = 3
                   DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%v2d(ib) = vn_b(ii,ij) * vmask(ii,ij,1)         
+                     ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                     ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                     dta_bdy(jbdy)%v2d(ib) = vn_b(ii,ij) * vmask(ii,ij,1)         
                   END DO 
-               END IF
-            ENDIF
-
-            IF( nn_dyn3d_dta(ib_bdy) == 0 ) THEN 
+               ENDIF
+            ENDIF
+            !
+            IF( nn_dyn3d_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
                IF( dta%ll_u3d ) THEN 
@@ -134,23 +136,23 @@
                   DO ib = 1, ilen1(igrd)
                      DO ik = 1, jpkm1
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%u3d(ib,ik) =  ( un(ii,ij,ik) - un_b(ii,ij) ) * umask(ii,ij,ik)         
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%u3d(ib,ik) =  ( un(ii,ij,ik) - un_b(ii,ij) ) * umask(ii,ij,ik)         
                      END DO
                   END DO 
-               END IF
+               ENDIF
                IF( dta%ll_v3d ) THEN 
                   igrd = 3 
                   DO ib = 1, ilen1(igrd)
                      DO ik = 1, jpkm1
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%v3d(ib,ik) =  ( vn(ii,ij,ik) - vn_b(ii,ij) ) * vmask(ii,ij,ik)         
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%v3d(ib,ik) =  ( vn(ii,ij,ik) - vn_b(ii,ij) ) * vmask(ii,ij,ik)         
                         END DO
                   END DO 
-               END IF
-            ENDIF
-
-            IF( nn_tra_dta(ib_bdy) == 0 ) THEN 
+               ENDIF
+            ENDIF
+
+            IF( nn_tra_dta(jbdy) == 0 ) THEN 
                ilen1(:) = nblen(:)
                IF( dta%ll_tem ) THEN
@@ -158,52 +160,24 @@
                   DO ib = 1, ilen1(igrd)
                      DO ik = 1, jpkm1
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_tem) * tmask(ii,ij,ik)         
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_tem) * tmask(ii,ij,ik)         
                      END DO
                   END DO 
-               END IF
+               ENDIF
                IF( dta%ll_sal ) THEN
                   igrd = 1 
                   DO ib = 1, ilen1(igrd)
                      DO ik = 1, jpkm1
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_sal) * tmask(ii,ij,ik)         
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_sal) * tmask(ii,ij,ik)         
                      END DO
                   END DO 
-               END IF
-            ENDIF
-
-#if defined key_lim2
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN 
-               ilen1(:) = nblen(:)
-               IF( dta%ll_frld ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%frld(ib) = frld(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-               IF( dta%ll_hicif ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%hicif(ib) = hicif(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-               IF( dta%ll_hsnif ) THEN
-                  igrd = 1 
-                  DO ib = 1, ilen1(igrd)
-                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%hsnif(ib) = hsnif(ii,ij) * tmask(ii,ij,1)         
-                  END DO 
-               END IF
-            ENDIF
-#elif defined key_lim3
-            IF( nn_ice_lim_dta(ib_bdy) == 0 ) THEN 
+               ENDIF
+            ENDIF
+
+#if defined key_lim3
+            IF( nn_ice_lim_dta(jbdy) == 0 ) THEN    ! set ice to initial values
                ilen1(:) = nblen(:)
                IF( dta%ll_a_i ) THEN
@@ -211,27 +185,27 @@
                   DO jl = 1, jpl
                      DO ib = 1, ilen1(igrd)
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%a_i (ib,jl) =  a_i(ii,ij,jl) * tmask(ii,ij,1) 
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%a_i (ib,jl) =  a_i(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
                ENDIF
-               IF( dta%ll_ht_i ) THEN
+               IF( dta%ll_h_i ) THEN
                   igrd = 1   
                   DO jl = 1, jpl
                      DO ib = 1, ilen1(igrd)
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%ht_i (ib,jl) =  ht_i(ii,ij,jl) * tmask(ii,ij,1) 
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%h_i (ib,jl) =  h_i(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
                ENDIF
-               IF( dta%ll_ht_s ) THEN
+               IF( dta%ll_h_s ) THEN
                   igrd = 1   
                   DO jl = 1, jpl
                      DO ib = 1, ilen1(igrd)
-                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                        dta_bdy(ib_bdy)%ht_s (ib,jl) =  ht_s(ii,ij,jl) * tmask(ii,ij,1) 
+                        ii = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij = idx_bdy(jbdy)%nbj(ib,igrd)
+                        dta_bdy(jbdy)%h_s (ib,jl) =  h_s(ii,ij,jl) * tmask(ii,ij,1) 
                      END DO
                   END DO
@@ -239,5 +213,5 @@
             ENDIF
 #endif
-         END DO ! ib_bdy
+         END DO ! jbdy
          !
       ENDIF ! kt == nit000
@@ -247,25 +221,25 @@
      
       jstart = 1
-      DO ib_bdy = 1, nb_bdy   
-         dta => dta_bdy(ib_bdy)
-         IF( nn_dta(ib_bdy) == 1 ) THEN ! skip this bit if no external data required
+      DO jbdy = 1, nb_bdy   
+         dta => dta_bdy(jbdy)
+         IF( nn_dta(jbdy) == 1 ) THEN ! skip this bit if no external data required
       
             IF( PRESENT(jit) ) THEN
                ! Update barotropic boundary conditions only
                ! jit is optional argument for fld_read and bdytide_update
-               IF( cn_dyn2d(ib_bdy) /= 'none' ) THEN
-                  IF( nn_dyn2d_dta(ib_bdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
+               IF( cn_dyn2d(jbdy) /= 'none' ) THEN
+                  IF( nn_dyn2d_dta(jbdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
                      IF( dta%ll_ssh ) dta%ssh(:) = 0._wp
                      IF( dta%ll_u2d ) dta%u2d(:) = 0._wp
                      IF( dta%ll_u3d ) dta%v2d(:) = 0._wp
                   ENDIF
-                  IF (cn_tra(ib_bdy) /= 'runoff') THEN
-                     IF( nn_dyn2d_dta(ib_bdy) == 1 .OR. nn_dyn2d_dta(ib_bdy) == 3 ) THEN
+                  IF (cn_tra(jbdy) /= 'runoff') THEN
+                     IF( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 ) THEN
 
                         jend = jstart + dta%nread(2) - 1
-                        IF( ln_full_vel_array(ib_bdy) ) THEN
+                        IF( ln_full_vel_array(jbdy) ) THEN
                            CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),  &
                                      & kit=jit, kt_offset=time_offset , jpk_bdy=nb_jpk_bdy,   &
-                                     & fvl=ln_full_vel_array(ib_bdy)  )
+                                     & fvl=ln_full_vel_array(jbdy)  )
                         ELSE
                            CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),  &
@@ -274,13 +248,13 @@
 
                         ! If full velocities in boundary data then extract barotropic velocities from 3D fields
-                        IF( ln_full_vel_array(ib_bdy) .AND.                                             &
-                          &    ( nn_dyn2d_dta(ib_bdy) == 1 .OR. nn_dyn2d_dta(ib_bdy) == 3 .OR.  &
-                          &      nn_dyn3d_dta(ib_bdy) == 1 ) )THEN
+                        IF( ln_full_vel_array(jbdy) .AND.                                             &
+                          &    ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 .OR.  &
+                          &      nn_dyn3d_dta(jbdy) == 1 ) )THEN
 
                            igrd = 2                      ! zonal velocity
                            dta%u2d(:) = 0._wp
-                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                           DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                              ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                               DO ik = 1, jpkm1
                                  dta%u2d(ib) = dta%u2d(ib) &
@@ -291,7 +265,7 @@
                            igrd = 3                      ! meridional velocity
                            dta%v2d(:) = 0._wp
-                           DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                              ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                              ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                           DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                              ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                              ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                               DO ik = 1, jpkm1
                                  dta%v2d(ib) = dta%v2d(ib) &
@@ -302,6 +276,6 @@
                         ENDIF                    
                      ENDIF
-                     IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                        CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta, td=tides(ib_bdy),   & 
+                     IF( nn_dyn2d_dta(jbdy) .ge. 2 ) THEN ! update tidal harmonic forcing
+                        CALL bdytide_update( kt=kt, idx=idx_bdy(jbdy), dta=dta, td=tides(jbdy),   & 
                           &                 jit=jit, time_offset=time_offset )
                      ENDIF
@@ -309,24 +283,24 @@
                ENDIF
             ELSE
-               IF (cn_tra(ib_bdy) == 'runoff') then      ! runoff condition
-                  jend = nb_bdy_fld(ib_bdy)
+               IF (cn_tra(jbdy) == 'runoff') then      ! runoff condition
+                  jend = nb_bdy_fld(jbdy)
                   CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend),  &
                                & map=nbmap_ptr(jstart:jend), kt_offset=time_offset )
                   !
                   igrd = 2                      ! zonal velocity
-                  DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                     ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                  DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                     ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                     ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                      dta%u2d(ib) = dta%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
                   END DO
                   !
                   igrd = 3                      ! meridional velocity
-                  DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                     ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                     ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                  DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                     ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                     ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                      dta%v2d(ib) = dta%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
                   END DO
                ELSE
-                  IF( nn_dyn2d_dta(ib_bdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
+                  IF( nn_dyn2d_dta(jbdy) == 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
                      IF( dta%ll_ssh ) dta%ssh(:) = 0._wp
                      IF( dta%ll_u2d ) dta%u2d(:) = 0._wp
@@ -337,15 +311,15 @@
                      CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), &
                                   & map=nbmap_ptr(jstart:jend), kt_offset=time_offset, jpk_bdy=nb_jpk_bdy,   &
-                                  & fvl=ln_full_vel_array(ib_bdy) )
+                                  & fvl=ln_full_vel_array(jbdy) )
                   ENDIF
                   ! If full velocities in boundary data then split into barotropic and baroclinic data
-                  IF( ln_full_vel_array(ib_bdy) .and.                                             &
-                    & ( nn_dyn2d_dta(ib_bdy) == 1 .OR. nn_dyn2d_dta(ib_bdy) == 3 .OR. &
-                    &   nn_dyn3d_dta(ib_bdy) == 1 ) ) THEN
+                  IF( ln_full_vel_array(jbdy) .and.                                             &
+                    & ( nn_dyn2d_dta(jbdy) == 1 .OR. nn_dyn2d_dta(jbdy) == 3 .OR. &
+                    &   nn_dyn3d_dta(jbdy) == 1 ) ) THEN
                      igrd = 2                      ! zonal velocity
                      dta%u2d(:) = 0._wp
-                     DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                        ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                        ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                         DO ik = 1, jpkm1
                            dta%u2d(ib) = dta%u2d(ib) &
@@ -359,7 +333,7 @@
                      igrd = 3                      ! meridional velocity
                      dta%v2d(:) = 0._wp
-                     DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
-                        ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                        ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     DO ib = 1, idx_bdy(jbdy)%nblen(igrd)
+                        ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                        ij   = idx_bdy(jbdy)%nbj(ib,igrd)
                         DO ik = 1, jpkm1
                            dta%v2d(ib) = dta%v2d(ib) &
@@ -375,24 +349,29 @@
                ENDIF
 #if defined key_lim3
-               IF( .NOT. ll_bdylim3 .AND. cn_ice_lim(ib_bdy) /= 'none' .AND. nn_ice_lim_dta(ib_bdy) == 1 ) THEN ! bdy ice input (case input is lim2 type)
-     	          CALL lim_var_itd ( bf(jfld_hti)%fnow(:,1,1), bf(jfld_hts)%fnow(:,1,1), bf(jfld_ai)%fnow(:,1,1), &
-                                  & dta_bdy(ib_bdy)%ht_i,     dta_bdy(ib_bdy)%ht_s,     dta_bdy(ib_bdy)%a_i     )
+               IF( cn_ice_lim(jbdy) /= 'none' .AND. nn_ice_lim_dta(jbdy) == 1 ) THEN
+                  IF( nice_cat == 1 ) THEN ! case input cat = 1
+                     CALL ice_var_itd ( bf(jfld_hti)%fnow(:,1,1), bf(jfld_hts)%fnow(:,1,1), bf(jfld_ai)%fnow(:,1,1), &
+                        &               dta_bdy(jbdy)%h_i     , dta_bdy(jbdy)%h_s     , dta_bdy(jbdy)%a_i    )
+                  ELSEIF( nice_cat /= 1 .AND. nice_cat /= jpl ) THEN ! case input cat /=1 and /=jpl
+                     CALL ice_var_itd2( bf(jfld_hti)%fnow(:,1,:), bf(jfld_hts)%fnow(:,1,:), bf(jfld_ai)%fnow(:,1,:), &
+                        &               dta_bdy(jbdy)%h_i     , dta_bdy(jbdy)%h_s     , dta_bdy(jbdy)%a_i    )
+                  ENDIF
                ENDIF
 #endif
             ENDIF
             jstart = jstart + dta%nread(1)
-         END IF ! nn_dta(ib_bdy) = 1
-      END DO  ! ib_bdy
+         ENDIF    ! nn_dta(jbdy) = 1
+      END DO  ! jbdy
 
       IF ( ln_tide ) THEN
          IF (ln_dynspg_ts) THEN      ! Fill temporary arrays with slow-varying bdy data                           
-            DO ib_bdy = 1, nb_bdy    ! Tidal component added in ts loop
-               IF ( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN
-                  nblen => idx_bdy(ib_bdy)%nblen
-                  nblenrim => idx_bdy(ib_bdy)%nblenrim
-                  IF( cn_dyn2d(ib_bdy) == 'frs' ) THEN; ilen1(:)=nblen(:) ; ELSE ; ilen1(:)=nblenrim(:) ; ENDIF 
-                  IF ( dta_bdy(ib_bdy)%ll_ssh ) dta_bdy_s(ib_bdy)%ssh(1:ilen1(1)) = dta_bdy(ib_bdy)%ssh(1:ilen1(1))
-                  IF ( dta_bdy(ib_bdy)%ll_u2d ) dta_bdy_s(ib_bdy)%u2d(1:ilen1(2)) = dta_bdy(ib_bdy)%u2d(1:ilen1(2))
-                  IF ( dta_bdy(ib_bdy)%ll_v2d ) dta_bdy_s(ib_bdy)%v2d(1:ilen1(3)) = dta_bdy(ib_bdy)%v2d(1:ilen1(3))
+            DO jbdy = 1, nb_bdy    ! Tidal component added in ts loop
+               IF ( nn_dyn2d_dta(jbdy) .ge. 2 ) THEN
+                  nblen => idx_bdy(jbdy)%nblen
+                  nblenrim => idx_bdy(jbdy)%nblenrim
+                  IF( cn_dyn2d(jbdy) == 'frs' ) THEN; ilen1(:)=nblen(:) ; ELSE ; ilen1(:)=nblenrim(:) ; ENDIF 
+                  IF ( dta_bdy(jbdy)%ll_ssh ) dta_bdy_s(jbdy)%ssh(1:ilen1(1)) = dta_bdy(jbdy)%ssh(1:ilen1(1))
+                  IF ( dta_bdy(jbdy)%ll_u2d ) dta_bdy_s(jbdy)%u2d(1:ilen1(2)) = dta_bdy(jbdy)%u2d(1:ilen1(2))
+                  IF ( dta_bdy(jbdy)%ll_v2d ) dta_bdy_s(jbdy)%v2d(1:ilen1(3)) = dta_bdy(jbdy)%v2d(1:ilen1(3))
                ENDIF
             END DO
@@ -404,11 +383,11 @@
 
       IF ( ln_apr_obc ) THEN
-         DO ib_bdy = 1, nb_bdy
-            IF (cn_tra(ib_bdy) /= 'runoff')THEN
+         DO jbdy = 1, nb_bdy
+            IF (cn_tra(jbdy) /= 'runoff')THEN
                igrd = 1                      ! meridional velocity
-               DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
-                  ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%ssh(ib) = dta_bdy(ib_bdy)%ssh(ib) + ssh_ib(ii,ij)
+               DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)
+                  ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                  ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+                  dta_bdy(jbdy)%ssh(ib) = dta_bdy(jbdy)%ssh(ib) + ssh_ib(ii,ij)
                END DO
             ENDIF
@@ -431,5 +410,5 @@
       !!                
       !!----------------------------------------------------------------------
-      INTEGER ::   ib_bdy, jfld, jstart, jend, ierror, ios     ! Local integers
+      INTEGER ::   jbdy, jfld, jstart, jend, ierror, ios     ! Local integers
       !
       CHARACTER(len=100)                     ::   cn_dir        ! Root directory for location of data files
@@ -437,5 +416,5 @@
       CHARACTER(len = 256)::   clname                           ! temporary file name
       LOGICAL                                ::   ln_full_vel   ! =T => full velocities in 3D boundary data
-                                                                ! =F => baroclinic velocities in 3D boundary data
+      !                                                         ! =F => baroclinic velocities in 3D boundary data
       INTEGER                                ::   ilen_global   ! Max length required for global bdy dta arrays
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   ilen1, ilen3  ! size of 1st and 3rd dimensions of local arrays
@@ -445,5 +424,6 @@
       TYPE(OBC_DATA), POINTER                ::   dta           ! short cut
 #if defined key_lim3
-      INTEGER               ::   zndims   ! number of dimensions in an array (i.e. 3 = wo ice cat; 4 = w ice cat)
+      INTEGER               ::   kndims   ! number of dimensions in an array (i.e. 3 = wo ice cat; 4 = w ice cat)
+      INTEGER, DIMENSION(4) ::   kdimsz   ! size   of dimensions
       INTEGER               ::   inum,id1 ! local integer
 #endif
@@ -451,14 +431,10 @@
       TYPE(FLD_N) ::   bn_tem, bn_sal, bn_u3d, bn_v3d   ! 
       TYPE(FLD_N) ::   bn_ssh, bn_u2d, bn_v2d           ! informations about the fields to be read
-#if defined key_lim2
-      TYPE(FLD_N) ::   bn_frld, bn_hicif, bn_hsnif      !
-#elif defined key_lim3
-      TYPE(FLD_N) ::   bn_a_i, bn_ht_i, bn_ht_s      
+#if defined key_lim3
+      TYPE(FLD_N) ::   bn_a_i, bn_h_i, bn_h_s      
 #endif
       NAMELIST/nambdy_dta/ cn_dir, bn_tem, bn_sal, bn_u3d, bn_v3d, bn_ssh, bn_u2d, bn_v2d 
-#if defined key_lim2
-      NAMELIST/nambdy_dta/ bn_frld, bn_hicif, bn_hsnif
-#elif defined key_lim3
-      NAMELIST/nambdy_dta/ bn_a_i, bn_ht_i, bn_ht_s
+#if defined key_lim3
+      NAMELIST/nambdy_dta/ bn_a_i, bn_h_i, bn_h_s
 #endif
       NAMELIST/nambdy_dta/ ln_full_vel, nb_jpk_bdy
@@ -473,13 +449,13 @@
 
       ! Set nn_dta
-      DO ib_bdy = 1, nb_bdy
-         nn_dta(ib_bdy) = MAX(  nn_dyn2d_dta(ib_bdy)       &
-                               ,nn_dyn3d_dta(ib_bdy)       &
-                               ,nn_tra_dta(ib_bdy)         &
-#if ( defined key_lim2 || defined key_lim3 )
-                              ,nn_ice_lim_dta(ib_bdy)    &
+      DO jbdy = 1, nb_bdy
+         nn_dta(jbdy) = MAX(   nn_dyn2d_dta  (jbdy)    &
+            &                , nn_dyn3d_dta  (jbdy)    &
+            &                , nn_tra_dta    (jbdy)    &
+#if defined key_lim3
+            &                , nn_ice_lim_dta(jbdy)    &
 #endif
                               )
-         IF(nn_dta(ib_bdy) > 1) nn_dta(ib_bdy) = 1
+         IF(nn_dta(jbdy) > 1)   nn_dta(jbdy) = 1
       END DO
 
@@ -488,20 +464,20 @@
       ALLOCATE( nb_bdy_fld(nb_bdy) )
       nb_bdy_fld(:) = 0
-      DO ib_bdy = 1, nb_bdy         
-         IF( cn_dyn2d(ib_bdy) /= 'none' .and. ( nn_dyn2d_dta(ib_bdy) == 1 .or. nn_dyn2d_dta(ib_bdy) == 3 ) ) THEN
-            nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
-         ENDIF
-         IF( cn_dyn3d(ib_bdy) /= 'none' .and. nn_dyn3d_dta(ib_bdy) == 1 ) THEN
-            nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
-         ENDIF
-         IF( cn_tra(ib_bdy) /= 'none' .and. nn_tra_dta(ib_bdy) == 1  ) THEN
-            nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
-         ENDIF
-#if ( defined key_lim2 || defined key_lim3 )
-         IF( cn_ice_lim(ib_bdy) /= 'none' .and. nn_ice_lim_dta(ib_bdy) == 1  ) THEN
-            nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
+      DO jbdy = 1, nb_bdy         
+         IF( cn_dyn2d(jbdy) /= 'none' .AND. ( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) ) THEN
+            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 3
+         ENDIF
+         IF( cn_dyn3d(jbdy) /= 'none' .AND. nn_dyn3d_dta(jbdy) == 1 ) THEN
+            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 2
+         ENDIF
+         IF( cn_tra(jbdy) /= 'none' .AND. nn_tra_dta(jbdy) == 1  ) THEN
+            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 2
+         ENDIF
+#if defined key_lim3
+         IF( cn_ice_lim(jbdy) /= 'none' .AND. nn_ice_lim_dta(jbdy) == 1  ) THEN
+            nb_bdy_fld(jbdy) = nb_bdy_fld(jbdy) + 3
          ENDIF
 #endif               
-         IF(lwp) WRITE(numout,*) 'Maximum number of files to open =',nb_bdy_fld(ib_bdy)
+         IF(lwp) WRITE(numout,*) 'Maximum number of files to open =', nb_bdy_fld(jbdy)
       END DO            
 
@@ -529,6 +505,6 @@
       REWIND(numnam_cfg)
       jfld = 0 
-      DO ib_bdy = 1, nb_bdy         
-         IF( nn_dta(ib_bdy) == 1 ) THEN
+      DO jbdy = 1, nb_bdy         
+         IF( nn_dta(jbdy) == 1 ) THEN
             READ  ( numnam_ref, nambdy_dta, IOSTAT = ios, ERR = 901)
 901         IF( ios /= 0 )   CALL ctl_nam ( ios , 'nambdy_dta in reference namelist', lwp )
@@ -538,15 +514,15 @@
             IF(lwm) WRITE( numond, nambdy_dta )
 
-            cn_dir_array(ib_bdy) = cn_dir
-            ln_full_vel_array(ib_bdy) = ln_full_vel
-
-            nblen => idx_bdy(ib_bdy)%nblen
-            nblenrim => idx_bdy(ib_bdy)%nblenrim
-            dta => dta_bdy(ib_bdy)
+            cn_dir_array(jbdy) = cn_dir
+            ln_full_vel_array(jbdy) = ln_full_vel
+
+            nblen => idx_bdy(jbdy)%nblen
+            nblenrim => idx_bdy(jbdy)%nblenrim
+            dta => dta_bdy(jbdy)
             dta%nread(2) = 0
 
             ! Only read in necessary fields for this set.
             ! Important that barotropic variables come first.
-            IF( nn_dyn2d_dta(ib_bdy) == 1 .or. nn_dyn2d_dta(ib_bdy) == 3 ) THEN 
+            IF( nn_dyn2d_dta(jbdy) == 1 .or. nn_dyn2d_dta(jbdy) == 3 ) THEN 
 
                IF( dta%ll_ssh ) THEN 
@@ -554,5 +530,5 @@
                   jfld = jfld + 1
                   blf_i(jfld) = bn_ssh
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 1
                   ilen1(jfld) = nblen(igrid(jfld))
@@ -561,9 +537,9 @@
                ENDIF
 
-               IF( dta%ll_u2d .and. .not. ln_full_vel_array(ib_bdy) ) THEN
+               IF( dta%ll_u2d .and. .not. ln_full_vel_array(jbdy) ) THEN
                   if(lwp) write(numout,*) '++++++ reading in u2d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u2d
-                  ibdy(jfld) = ib_bdy
+                  ibdy(jfld) = jbdy
                   igrid(jfld) = 2
                   ilen1(jfld) = nblen(igrid(jfld))
